val scala3: String = "3.4.2"

ThisBuild / scalaVersion  := scala3
ThisBuild / versionScheme := Some("semver-spec")
ThisBuild / gsProjectName := "gs-datagen"

ThisBuild / externalResolvers := Seq(
  "Garrity Software Mirror" at "https://maven.garrity.co/releases",
  "Garrity Software Releases" at "https://maven.garrity.co/gs"
)

val noPublishSettings = Seq(
  publish := {}
)

val sharedSettings = Seq(
  scalaVersion          := scala3,
  version               := semVerSelected.value,
  coverageFailOnMinimum := true
  /* coverageMinimumStmtTotal := 100, coverageMinimumBranchTotal := 100 */
)

lazy val testSettings = Seq(
  libraryDependencies ++= Seq(
    "org.scalameta" %% "munit" % "1.0.0" % Test
  )
)

lazy val `gs-datagen` = project
  .in(file("."))
  .aggregate(core)
  .settings(noPublishSettings)
  .settings(name := s"${gsProjectName.value}-v${semVerMajor.value}")

lazy val core = project
  .in(file("modules/core"))
  .settings(sharedSettings)
  .settings(testSettings)
  .settings(name := s"${gsProjectName.value}-core-v${semVerMajor.value}")
  .settings(
    libraryDependencies ++= Seq(
      "gs" %% "gs-uuid-v0" % "0.2.4"
    )
  )
