package gs.datagen.v0.generators

import gs.datagen.v0.Gen
import java.time.LocalDate

trait GenLocalDate extends Gen[LocalDate]

object GenLocalDate:

  final class Before(
    val pivot: LocalDate,
    val days: MinMax,
    val months: MinMax,
    val years: MinMax
  ) extends GenLocalDate:

    override def generate(input: Any): LocalDate =
      val rng = Gen.rng()
      pivot
        .minusDays(days.select(rng).toInt)
        .minusMonths(months.select(rng).toInt)
        .minusYears(years.select(rng).toInt)

  final class After(
    val pivot: LocalDate,
    val days: MinMax,
    val months: MinMax,
    val years: MinMax
  ) extends GenLocalDate:

    override def generate(input: Any): LocalDate =
      val rng = Gen.rng()
      pivot
        .plusDays(days.select(rng).toInt)
        .plusMonths(months.select(rng).toInt)
        .plusYears(years.select(rng).toInt)

end GenLocalDate
