package gs.datagen.v0.generators

import gs.datagen.v0.Gen

abstract class GenMap[K, V] extends Gen[Map[K, V]]

object GenMap:

  final class IndependentKeyValue[K, V](
    val size: Size,
    val keyGen: Gen[K],
    val valueGen: Gen[V]
  ) extends Gen[Map[K, V]]:

    override def generate(input: Any): Map[K, V] =
      List.fill(size.next(Gen.rng()))(generateTuple()).toMap

    private def generateTuple(): (K, V) =
      keyGen.generate(()) -> valueGen.generate(())

  final class CoupledKeyValue[K, V](
    val size: Size,
    val keyValueGen: Gen[(K, V)]
  ) extends Gen[Map[K, V]]:

    override def generate(input: Any): Map[K, V] =
      List.fill(size.next(Gen.rng()))(keyValueGen.generate(())).toMap

end GenMap
